
{========================================================================================)
  Component TDhCheckFolder Version 1.1, Dec. 2000
{========================================================================================)


    Description:
    ============
    Displays all System-Folder and Drives ( Network too ). All folder with State-Icons
    and you can check them and save the checks to disk.


    Author:
    =======
    (c) Hubert Indetzki 1998, 2000
    Dammer Hof 12
    49088 Osnabrueck
    Germany


    V 1.0:
     - now running under Delphi 4.0
     - changed Component-Name from SystemFolderList to DhCheckFolder
     - added Desktop-Icon
     - added property ChangeFolder
     - removed property StateBoxes
     - changed procedure CreateStates               r1
     - added property CheckBoxes                    r1
     - added CheckDriveList                         r1
     - procedure KeyDown changed (better Ergonomy)  r1
     - changed CheckDriveList to public             r1
    V 1.1:
     - Network supported
     - added procedure SaveCheckedFolder
     - added public procedure SetInitialDir
     - added RefreshNode                            r1
     - whole Network supported                      r1
     - Desktop-Folder supported                     r2
     - Now compatible with Windows 98 ME            r3
     - removed RefreshNode                          r3

{========================================================================================}


unit DhCheckFolder11;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ShellApi, ShlObj, ComObj, Commctrl, ActiveX, StdCtrls, ExtCtrls,
  Menus, FileCtrl, {DhCheckFiles12, }BasicUnit10;


const
  NOT_CHECKED = $01;
  CHECKED = $02;
  GRAY_CHECKED = $03;
  NEUTRAL = $04;
  crPencil = $05;
  TIMER_INTERVALL = 100;
const
  DEFAULT_INITIAL_DIR = 'C:\';
  WINDOWS_DRIVE = 'C:\';
  DESKTOP_PATH = 'C:\Windows\Desktop';
  DOUBLE_SLASH = '\\';
const
  SFGAO_CANCOPY           = DROPEFFECT_COPY; { Objects can be copied }
  SFGAO_CANMOVE           = DROPEFFECT_MOVE; { Objects can be moved }
  SFGAO_CANLINK           = DROPEFFECT_LINK; { Objects can be linked }
  SFGAO_CANRENAME         = $00000010;       { Objects can be renamed }
  SFGAO_CANDELETE         = $00000020;       { Objects can be deleted }
  SFGAO_HASPROPSHEET      = $00000040;       { Objects have property sheets }
  SFGAO_DROPTARGET        = $00000100;       { Objects are drop target }
  SFGAO_CAPABILITYMASK    = $00000177;
  SFGAO_LINK              = $00010000;       { Shortcut (link) }
  SFGAO_SHARE             = $00020000;       { shared }
  SFGAO_READONLY          = $00040000;       { read-only }
  SFGAO_GHOSTED           = $00080000;       { ghosted icon }
  SFGAO_HIDDEN            = $00080000;       { hidden object }
  SFGAO_DISPLAYATTRMASK   = $000F0000;
  SFGAO_FILESYSANCESTOR   = $10000000;       { It contains file system folder }
  SFGAO_FOLDER            = $20000000;       { It's a folder. }
  SFGAO_FILESYSTEM        = $40000000;       { is a file system thing (file/folder/root) }
  SFGAO_HASSUBFOLDER      = $80000000;       { Expandable in the map pane }
  SFGAO_CONTENTSMASK      = $80000000;
  SFGAO_VALIDATE          = $01000000;       { invalidate cached information }
  SFGAO_REMOVABLE         = $02000000;       { is this removeable media? }
  SFGAO_COMPRESSED        = $04000000;       { Object is compressed (use alt color) }
  SFGAO_BROWSABLE         = $08000000;       { is in-place browsable }
  SFGAO_NONENUMERATED     = $00100000;       { is a non-enumerated object }
  SFGAO_NEWCONTENT        = $00200000;       { should show bold in explorer tree }

  // Peter Stotz says : All-Attributes is passed to an IShellFolder when creating or
  // updating a node. The remarked attributes cause on some systems an access to the
  // drives A and B.
  ALL_ATRIBUTES =  SFGAO_HASPROPSHEET or SFGAO_DROPTARGET or SFGAO_CAPABILITYMASK or
                   SFGAO_LINK or SFGAO_SHARE or SFGAO_GHOSTED or SFGAO_FILESYSANCESTOR or
                   SFGAO_FOLDER or SFGAO_FILESYSTEM or SFGAO_HASSUBFOLDER or
                   SFGAO_CONTENTSMASK or SFGAO_REMOVABLE or SFGAO_COMPRESSED;
                   {SFGAO_CANRENAME or SFGAO_CANDELETE or SFGAO_READONLY or SFGAO_VALIDATE
                    or SFGAO_DISPLAYATTRMASK}

  WEB_ATTR_DOS = $14;             // "C:\Windows\Web";                            SysFile
  COOKIES_ATTR_DOS = $14;         // "C:\Windows\Cookies";                        SysFile
  TI_FILES_ATTR_DOS = $16;        // "C:\Windows\Temporary Internet Files";       SysFile
  HIS6_ATTR_DOS = $16;            // "C:\Windows\His6;                            SysFile
  RECYCLED_ATTR_DOS = $16;        // virtual folder;                              SysFile
  HISTORY_ATTR_DOS = $14;         // virtual folder;                              SysFile
  DPF_ATTR_DOS = $14;             // virtual folder ( Downloaded Program Files ); SysFile
  OW_ATTR_DOS =  $11;             // virtual folder ( Offline Webpages )

  DESKTOP_ATTR = $F0000050;       // Desktop-Icon (items[0])
  WORKSTATION_ATTR = $B0000154;   // Workstation-Icon (items[1])
  NETWORK_MAIN_ATTR = $B0000144;  // Network-Root-Main-Icon
  NETWORK_SUB_ATTR = $B0000044;   // whole network + workgroup + client, server

  WHOLE_NETWORK_ICON = $0D;       // Whole-Network-Icon ( tested on my machine !!! )
                                  // If not the same on yours, then you must change it.
  WORKSTATION_ICON = $32;         // local Workstation
  NETWORK_MAIN_ICON = $12;        // Network-MainIcon
  WORKGROUP_ICON = $12;           // WorkGroup-Icon
  HOST_ICON = $0F;                // RootIcon for the Network-Drives
  NORMAL_FOLDER_ICON = $03;

  DESKTOP_FOLDER : array[1..2] of integer = ( CSIDL_DRIVES, CSIDL_NETWORK );


type
  TOnChangeFolderEvent = procedure ( path : string ) of object;
  TOnCheckFolderReady = procedure ( count : integer ) of object;
  TDhCheckFolder = class(TCustomTreeView)
  private
   //fVirtualFolder : boolean;
   fCheckedFolderCount : integer;
   fCheckedFolderList : tStringList;
   fFirstRead : boolean;
   FHasChanged : boolean;
   //FCheckFiles : TDhCheckFiles;
   fCurNode : tTreeNode;
   fNetworkMainAttr : ULONG;
   fNetworkSubAttr : ULONG;
   fDesktopIcon : integer;
   fWorkstationIcon : integer;
   fNetWorkIcon : integer;
   fSortFolder : boolean;
   fInitialDir : string;
   fCheckBoxes : boolean;
   fRootShellFolder : iShellFolder;
   fSomeFolderChecked : boolean;
   fOnChangeFolder : tOnChangeFolderEvent;
   fCurDir : string;
   fPidlPath : PItemIdList;
   fCanExpand : boolean;
   fItemsCount : integer;
   fCheckFolderReady : tOnCheckFolderReady;
   fStateImageList : tImageList;
   fFullPidlPathList : tList;
  protected
   function CountCheckedFolder : integer;
   //procedure SetCheckFiles ( CF : TDhCheckFiles );
   procedure MakeDriveVisible ( list : tStringList );
   procedure CheckFolder ( node : tTreeNode );
   procedure CreateWnd; override;
   procedure DestroyWnd; override;
   procedure Loaded; override;
   procedure SetCheckBoxes ( value : boolean );
   function GetStateChecked : integer;
   procedure SetStateChecked ( state : integer );
   function GetCheckedFolderList : tStringList;
   procedure AddCheckedFolderToList ( folder : string );
   procedure InitialisizeComponent;
   procedure AddSubNodesWithFolder ( path : string; RealFolder, AllFolder : boolean );
   procedure AddSubNodesWithNode ( node : tTreeNode );
   function ExploreNetwork : boolean;
   procedure SwitchStateIndex ( node : tTreeNode; attr : ULONG );
   procedure EnumerateFolder (  ShellFolder: IShellFolder; RealFolder : boolean;
                                                    AllFolder : boolean; node : tTreeNode );
   procedure ClearAllItems;
   //procedure RefreshNode ( node : tTreeNode );
   function ProofStates ( node : tTreeNode ) : boolean;
   procedure MouseMove( Shift: TShiftState; X, Y: Integer); override;
   procedure click; override;
   procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
   procedure Changing ( Sender: TObject; Node: TTreeNode; var AllowChange: Boolean );
   procedure Change ( Node: TTreeNode ); override;

   procedure KeyDown (  var Key: Word; Shift: TShiftState ); override;
   procedure KeyUp (  var Key: Word; Shift: TShiftState ); override;
   function CanExpand ( node: tTreeNode ) : boolean; override;
   function CanCollapse ( node: tTreeNode ) : boolean; override;
   function CheckSibling ( node : tTreeNode ) : boolean;
   procedure CheckSubFolder ( node : tTreeNode );
   procedure CreateImages;
   procedure CreateStates;
  public
   function SubFolderChecked ( node : tTreeNode ) : boolean;
   procedure ReCreatePathInTree ( path : string; node : tTreeNode; visible : boolean );
   function FindNodeInTreeView ( StartNode : tTreeNode; path : string ): integer;
   function CurNode : tTreeNode;
   procedure CheckParentFolder ( node : tTreeNode );
   property PidlPath : PItemIdList read fPidlPath;
   constructor create (aOwner: tComponent); override;
   destructor destroy; override;
   property Directory : string read fCurDir;
   procedure ClearAllChecks;
   procedure SetInitialDir ( path : string );
   procedure SaveChecksToDisk ( FileName : string );
   procedure LoadChecksFromDisk ( FileName : string );
  published
   // link to the ListView-Component
   //property LinkToCheckFiles : TDhCheckFiles read FCheckFiles write SetCheckFiles;
   property CheckBoxes : boolean read FCheckBoxes write SetCheckBoxes
    default true;
   property OnChangeFolder : tOnChangeFolderEvent read fOnChangeFolder
                                                          write fOnChangeFolder;
   property NodeChecked : integer read GetStateChecked write SetStateChecked
    default NOT_CHECKED;
   property CheckedFolderCount : integer read fCheckedFolderCount;
   property OnCheckFolderReady : tOnCheckFolderReady read fCheckFolderReady
                                             write fCheckFolderReady;
   property CheckedFolderList : tStringList read GetCheckedFolderList
                                            write fCheckedFolderList;
   property AutoExpand;
   property ReadOnly;
   property Align;
   property Enabled;
   property Font;
   property HideSelection;
   property Items;
   property ParentColor;
   property PopupMenu;
   property Selected;
   property TabOrder;
   property TabStop default true;
   property Visible;
   //property OnMouseMove;
  end;


{ *************************** SUBROUTINES ************************************* }
function CountCharsInString ( s : string; c : char ) : integer;
function GetPidlFileAttribut ( path : string ) : boolean;
function CombinePidls ( id1, id2 : PItemIDList ) : PItemIDList;

function GetPidlSize ( pidl: PItemIdList ) : integer;
function GetDirectory ( ShellFolder : IShellFolder; idList : PItemIDList; Flags : DWORD ) :
                                                                                   string;
function GetSelectedIcon ( list : PItemIdList ) : integer;
function GetNormalIcon ( list : PItemIdList ) : integer;


procedure Register;

implementation

{$R DhCheckFolder11.res}



var
  ShellMalloc : iMalloc;


function CountCharsInString ( s : string; c : char ) : integer;
var
  i : integer;
begin
  result := 0;
  i := pos ( c, s );
  while i > 0 do
   begin
    inc(result);
    s := copy ( s, i+1, pred(length(s)) );
    i := pos ( c, s );
   end;
end;


function IsItADrive ( path : string ) : boolean;
var
  info : tShFileInfo;
  HexAttr : string;
begin
  result := false;
  FillChar ( info.szTypeName, 80, ' ' );
  SHGetFileInfo ( PChar( path), 0, info, sizeof ( info ), SHGFI_ATTRIBUTES or//);
                                                                         SHGFI_TYPENAME );
  HexAttr := IntToHex (info.dwAttributes, 4);
  //if ( info.dwAttributes = DRIVE_ATTR ) then
  if ( info.szTypeName = 'Hallo' ) then
   result := true;
end;


function GetPidlFileAttribut ( path : string ) : boolean;
var
  info : tShFileInfo;
begin
  result := false;
  SHGetFileInfo ( PChar( path), 0, info, sizeof ( info ), SHGFI_ATTRIBUTES );
  if ( info.dwAttributes and SFGAO_FILESYSTEM ) > 0 then
   result := true;
end;


procedure SplitPathToList ( path : string; list : tStringList );
var
  index : integer;
  dir : string;
  temp : string;
begin
  path := AddSlash ( path );
  temp := path;
  index := pos ( '\', temp  );
  while index > 0 do
   begin
    dir := copy ( path, 1, pred(index) );
    if length(dir) > 1 then list.add ( dir );
    temp[index] := ' ';
    index := pos ( '\', temp  );
   end;
end;


function GetPidlSize ( pidl: PItemIdList ): integer;
begin
  result := 0;
  if pidl <> nil then
   begin
    inc ( result, SizeOf(pidl^.mkid.cb) );
    while pidl^.mkid.cb <> 0 do
     begin
      inc ( result, pidl^.mkid.cb );
      inc ( longint(pidl), pidl^.mkid.cb );
     end;
   end;
end;


function CreatePIDL ( size: UINT): PItemIDList;
begin
  result := ShellMalloc.Alloc(size);
  if result <> nil then
   FillChar ( result^, size, #0 );
end;


function CombinePIDLs ( id1, id2: PItemIDList ): PItemIDList;
var
  s1, s2 : UINT;
begin
  if (id1 <> nil) then
   s1 := GetPIDLSize(id1) - SizeOf(id1.mkid.cb)
   else
    s1 := 0;
  s2 := GetPIDLSize(id2);

  result := CreatePIDL(s1 + s2);
  if result <> nil then
   begin
    if (id1 <> nil) then
     move ( id1^, result^, s1 );
    move ( id2^, PChar(result)[s1], s2 );
   end;
end;


function GetDirectory ( ShellFolder : iShellFolder;
                                 IdList : pItemIdList; flags : DWORD ) : string;
var
  str : tStrRet;
  name : string;
begin
  name := '';
  if ShellFolder.GetDisplayNameOf ( IdList, flags, str ) = NOERROR then
  begin
    case str.uType of
     STRRET_WSTR :
      name := WideCharToString(str.pOleStr);
     STRRET_OFFSET :
      name := PChar(ULONG(IdList) + str.uOffset);
     STRRET_CSTR :
      name := str.cStr;
    end;
  end;
  result := RemoveSlash ( name );
end;


function GetFolderAttribut ( list : pItemIdList ) : integer;
var
  info : tShFileInfo;
  HexAttr : string;
begin
  FillChar ( info.szDisplayName, MAX_PATH, ' ' );
  info.dwAttributes := $00000000;
  ShGetFileInfo ( PChar(list), 0, info, SizeOf(tShFileInfo), SHGFI_PIDL or
                                                   SHGFI_DISPLAYNAME or SHGFI_ATTRIBUTES );
  HexAttr := IntToHex ( info.dwAttributes, 4 );
  result := info.dwAttributes;
end;


function GetNormalIcon ( list : pItemIdList ) : integer;
var
  info : tShFileInfo;
begin
  ShGetFileInfo ( PChar(list), 0, info, SizeOf(tShFileInfo), SHGFI_PIDL or
                                             SHGFI_SYSICONINDEX or SHGFI_SMALLICON );
    result := info.iIcon;
end;


function GetSelectedIcon ( list : pItemIdList ) : integer;
var
  info : tShFileInfo;
begin
  ShGetFileInfo ( PChar(list), 0, info, SizeOf(tShFileInfo), SHGFI_PIDL or
                            SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_OPENICON );
  result := info.iIcon;
end;


constructor TDhCheckFolder.create;
begin
  inherited create(aOwner);
  width := 220;
  height := 140;
  CreateStates;
  CreateImages;
  fFirstRead := true;
  fHasChanged := false;
  fCheckBoxes := true;
  fCanExpand := true;
  fCurNode := nil;
  fDesktopIcon := -1;
  FWorkstationIcon := -1;
  FNetWorkIcon := -1;
  fNetworkMainAttr := 0;
  fNetworkSubAttr := 0;
  fSortFolder := true;
  fInitialDir := DEFAULT_INITIAL_DIR;
  fCurDir := DEFAULT_INITIAL_DIR;
  OnChanging := Changing;
  fFullPidlPathList := tList.create;
  fCheckedFolderList := tStringList.create;
  fCheckedFolderList.sorted := true;
  fCheckedFolderList.duplicates := dupIgnore;
end;


destructor TDhCheckFolder.destroy;
Begin
  ClearAllItems;
  fCheckedFolderList.free;
  fFullPidlPathList.free;
  images.free;
  if assigned ( StateImages ) then
   fStateImageList.free;
  inherited;
End;


procedure TDhCheckFolder.CreateWnd;
var
  index : integer;
begin
  inherited CreateWnd;

  font.size := 8;
  font.name := 'arial';

  if not ( csLoading in ComponentState ) then
   begin
    InitialisizeComponent;
    // select InitialDir
    index := FindNodeInTreeview ( items[0], fInitialDir );
    if index > 0 then items[index].selected := true;
   end;
end;


procedure TDhCheckFolder.DestroyWnd;
begin
  inherited DestroyWnd;
end;


procedure TDhCheckFolder.Loaded;
var
  index : integer;
begin
  inherited Loaded;
  InitialisizeComponent;
  // select InitialDir
  index := FindNodeInTreeview ( items[0], fInitialDir );
  if index > 0 then items[index].selected := true;
end;


{procedure TDhCheckFolder.SetCheckFiles ( CF : TDhCheckFiles );
begin
  if assigned ( FCheckFiles ) then
   FCheckFiles.LinkToCheckFolder := nil;

  FCheckFiles := CF;

  if assigned ( FCheckFiles ) then
   FCheckFiles.LinkToCheckFolder := self;
end;}


procedure TDhCheckFolder.SetCheckBoxes ( value : boolean );
begin
  fCheckBoxes := value;
  if value then
   StateImages := fStateImageList
    else
     StateImages := nil;
end;


function TDhCheckFolder.GetStateChecked : integer;
var
  node : tTreeNode;
begin
  fCanExpand := false;
  result := NOT_CHECKED;
  node := FCurNode;

  if node <> nil then
   begin
    //if node.text = 'hallo' then
    // beep;
    result := node.StateIndex;
   end;
end;


procedure TDhCheckFolder.SetStateChecked ( state : integer);
var
  node : tTreeNode;
begin
  fCanExpand := false;
  node := selected;
  if ( node <> nil ) and ( Node.AbsoluteIndex <> 0 )then
   Node.StateIndex := state;
end;


function TDhCheckFolder.CurNode : tTreeNode;
var
  node : tTreeNode;
begin
  node := selected;
  //if node.text = 'Hallo' then
  // beep;
  result := node;
end;


procedure TDhCheckFolder.SetInitialDir ( path : string );
var
  SplitPathList : tStringList;
  index : integer;
  i : integer;
  SplitPath : string;
Begin
  fInitialDir := path;
  if items.count = 0 then exit;
  SplitPathList := tStringList.create;
  screen.cursor := crHourGlass;
  if DirectoryExists ( path ) then
   begin
    SplitPathToList ( path, SplitPathList );
    // if there is a Network-Drive choosed
    for i:=0 to SplitPathList.count-2 do
     begin
      if pos ( DOUBLE_SLASH, path ) > 0 then
       begin
        if not ExploreNetwork then
         begin
          screen.cursor := crDefault;
          exit;
         end;
       end;
      SplitPath := SplitPathList[i];
      //if pos ( 'Windows', SplitPath ) > 0 then
      // beep;
      AddSubNodesWithFolder ( SplitPath, true, true );
     end;

    index := FindNodeInTreeView ( items[0], path );
    if index > 0 then
     begin
      fCanExpand := true;
      items[index].selected := true;
     end;
   end;
  screen.cursor := crDefault;
  SplitPathList.free;
End;


Procedure TDhCheckFolder.SaveChecksToDisk ( FileName : string ); //tTreeView
var
  list : tStringList;
  i : integer;
  node : tTreeNode;
  path : string;

Begin
  list := tStringList.create;
  // store checked folder
  for i:=0 to items.count-1 do
   begin
    node := items[i];
    if node.level >= 1 then
     begin
      if Node.StateIndex = CHECKED then
       begin
        if Node.GetFirstChild <> nil then
         if Node.GetFirstChild.StateIndex = CHECKED then
          continue;
        path := GetDirectory ( FRootShellFolder, node.data, SHGDN_FORPARSING );
        list.add ( path );
       end;
     end;
   end;
  list.SaveToFile ( FileName );
  list.free;
  // Save checks in ListView
  //if assigned ( FCheckFiles ) then
  // FCheckFiles.SaveChecksToDisk ( FileName );
End; { SaveCheckedFolder }


procedure TDhCheckFolder.LoadChecksFromDisk ( FileName : string );
var
  i, k : integer;
  SplitPathList : tStringList;
  path : string;
  node : tTreeNode;
  index : integer;
  SplitPath : string;
  OldPath : string;
  DoBreak : boolean;
  list : tStringList;

Begin
  screen.cursor := crHourGlass;
  SplitPathList := tStringList.create;
  list := tStringList.create;
  ClearAllChecks;
  list.LoadFromFile ( FileName );
  // add nodes if necessary
  OldPath := '';
  DoBreak := false;
  for i:=0 to list.count-1 do
   begin
    if DoBreak then break;
    SplitPathList.clear;
    if FileExists ( list[i] ) then
     continue;
    FCheckedFolderList.add ( list[i] );
    path := list[i];
    SplitPathToList ( path, SplitPathList );
    // add nodes without Sub-Nodes
    for k:=0 to SplitPathList.count-2 do
     begin
      SplitPath := SplitPathList[k];
      // add network drives
      if pos ( DOUBLE_SLASH, SplitPath ) > 0 then
       if not ExploreNetwork then DoBreak := true;
      if DoBreak then break;
      if OldPath <> SplitPath then
       AddSubNodesWithFolder ( SplitPath, true, true );
      OldPath := SplitPath;
     end;
   end;
  // check nodes if necessary
  if not DoBreak then
   begin
    node := items[0];
    for i:=0 to list.count-1 do
     begin
      index := FindNodeInTreeView ( node, list[i] );
      if index > 0 then
       CheckFolder ( items[index] );
      // if Desktop-Folder is checked
      if pos ( LowerCase(DESKTOP_PATH), LowerCase(list[i]) ) > 0 then
       begin
        node := items[index];
        index := FindNodeInTreeView ( Node.GetNext, list[i] );
        if index > 0 then
         CheckFolder ( items[index] );
        node := items[0];
       end;
     end;
   end;
  Application.ProcessMessages;
  // make drive visible
  if list.count > 0 then
   MakeDriveVisible ( list );
  screen.cursor := crDefault;
  SplitPathList.free;
  list.free;

  if DoBreak then
   begin
    MessageBeep ( MB_ICONASTERISK );
    MessageDlg ( 'There is no Network !', mtError, [mbOk], 0);
   end;

   // Load checks from ListView
  //if assigned ( FCheckFiles ) then
  // FCheckFiles.LoadChecksFromDisk ( FileName );
End; { LoadCheckedFolder }


procedure TDhCheckFolder.CheckFolder ( node : tTreeNode );
begin
  Node.StateIndex := CHECKED;
  CheckParentFolder ( node );
  CheckSubFolder ( node );
end;


procedure TDhCheckFolder.MakeDriveVisible ( list : tStringList );
var
  drive : string;
  node : tTreeNode;
  index : integer;
begin
  FCanExpand := true;
  drive := ExtractFileDrive ( list[0] );
  node := items[0];
  index := FindNodeInTreeView ( node, drive );
  if index > 0 then
   begin
    node := items[index];
    node.MakeVisible;
   end;
end;


Function TDhCheckFolder.GetCheckedFolderList : tStringList;
var
  node : tTreeNode;
  path : string;
  AddPath : boolean;

Begin
  fCheckedFolderList.clear;
  node := items[1];
  AddPath := true;
  while node <> nil do
   begin
    if ( Node.StateIndex = CHECKED ) then
     begin
      fPidlPath := node.data;
      path := GetDirectory ( FRootShellFolder, fPidlPath, SHGDN_FORPARSING );
      if AddPath then
       begin
        fCheckedFolderList.add ( path );
        AddCheckedFolderToList ( path );
        AddPath := false;
       end;
      if Node.GetNext <> nil then
       begin
        Node := Node.GetNext;
        if Node.Parent.StateIndex <> CHECKED then
         AddPath := true;
       end
        else break;
     end
      else Node := Node.GetNext;
   end; // end while do ..
  result := fCheckedFolderList;
End;


Procedure TDhCheckFolder.AddCheckedFolderToList ( folder : string );
var
   result : integer;
   f : tSearchRec;
   SubFolder : string;
   index : integer;

Begin
  result := FindFirst ( folder + '\*.*', faAnyFile, f );
  while result = 0 do
   begin
    if ( f.name[1] <> '.' ) then
     if ( f.attr and faDirectory > 0 ) then  { if folder then.. }
      begin
       //if pos ( 'Downloaded', f.name  ) > 0 then
       // beep;
       SubFolder := f.name;
       folder := folder + '\' + SubFolder;
       if ( f.attr and faSysFile = 0 ) then
        begin
         AddCheckedFolderToList ( folder );
         fCheckedFolderList.add ( folder ) ;
        end;
       index := length(folder) - length(SubFolder);
       system.delete ( folder, index, length(SubFolder) + 1 );
      end;
       {else if ( f.attr and faDirectory = 0 ) then  { if file then..
        if ( f.attr <> RECYCLED_ATTR_DOS ) then
         fCheckedFolderList.add ( folder + ' \' + f.name ); }
    result := FindNext( f );
   end; { end while do.. }
  FindClose ( F );
End;


procedure TDhCheckFolder.ClearAllChecks;
var
  node : tTreeNode;
begin
  fCheckedFolderList.clear;
  node := items[0];
  while node <> nil do
   begin
    if ( Node.StateIndex > 0 ) and ( Node.StateIndex <> NEUTRAL ) then
     Node.StateIndex := NOT_CHECKED;
    node := node.GetNext;
   end;
end;


Procedure TDhCheckFolder.InitialisizeComponent;
var
  FolderName : string;
  RootId : pItemIDList;
  ShellFolder : iShellFolder;
  node : tTreeNode;
  IdList : pItemIDList;
  i : integer;

Begin
  ClearAllItems;
  ShGetDesktopFolder ( FRootShellFolder );
  // Get the Desktop-Main-Icon
  ShGetSpecialFolderLocation ( handle, CSIDL_DESKTOP, RootId );
  FolderName := GetDirectory ( FRootShellFolder, RootId, SHGDN_NORMAL );
  Node := items.AddChildObject ( nil, FolderName, RootId );
  Node.ImageIndex := GetNormalIcon ( RootId );
  fDesktopIcon := Node.ImageIndex;
  Node.SelectedIndex := GetSelectedIcon ( RootId );
  Node.StateIndex := -1;
  node.data := RootId;
  fFullPidlPathList.add ( RootId );
  // Add Workstation and Network-Icon
  for i:=1 to 2 do
   begin
    ShGetSpecialFolderLocation ( handle, DESKTOP_FOLDER[i], RootId );
    FolderName := GetDirectory ( FRootShellFolder, RootId, SHGDN_NORMAL );
    Node := items.AddChildObject ( node, FolderName, RootId );
    Node.HasChildren := true;
    Node.ImageIndex := GetNormalIcon ( RootId );
    if i = 1 then FWorkstationIcon := Node.ImageIndex
     else FNetWorkIcon := Node.ImageIndex;
    Node.SelectedIndex := GetSelectedIcon ( RootId );
    Node.StateIndex := -1;
    node.data := RootId;
    fFullPidlPathList.add ( RootId );
    node := node.parent;
   end;
  // Add all dragged Folder on Desktop
  EnumerateFolder ( FRootShellFolder, true, false, node );

  // Add Whole-Network-Icon
  node := items[2];
  fNetworkMainAttr := GetFolderAttribut ( node.data );
  if node <> nil then
   begin
    IdList := node.data;
    FRootShellFolder.BindToObject ( IdList, nil, IID_IShellFolder, pointer(ShellFolder));
    EnumerateFolder ( ShellFolder, false, false, node );
    node := Node.GetNext;
    if node <> nil then
     fNetworkSubAttr := GetFolderAttribut ( node.data );  // Whole-Network-Icon
   end;
  // Add local drives
  node := items[1];
  IdList := node.data;
  FRootShellFolder.BindToObject ( IdList, nil, IID_IShellFolder, pointer(ShellFolder));
  EnumerateFolder ( ShellFolder, true, false, node );

  if fInitialDir <>  DEFAULT_INITIAL_DIR then
   SetInitialDir ( fInitialDir );
End; { InitialisizeComponent }


procedure TDhCheckFolder.AddSubNodesWithFolder ( path : string; RealFolder, AllFolder : boolean);
var
  PidlPath : pItemIDList;
  ShellFolder : iShellFolder;
  node : tTreeNode;
  index : integer;

Begin
  node := items[0];
  // Search current path in TreeView.
  index := FindNodeInTreeView ( node, path );
  if index > 0 then
   node := items[index]
    else exit;
  if ( node.GetFirstChild = nil ) then
   if ( node.HasChildren ) then
    begin
     PidlPath := node.data;
     // Get System-Folder in TreeView.
     FRootShellFolder.BindToObject ( PidlPath, nil, IID_IShellFolder, pointer(ShellFolder));
     EnumerateFolder ( ShellFolder, RealFolder, true, node );
     if fSortFolder then
      TreeView_SortChildren ( handle, node.ItemId, 0 );
    end;
End;


function TDhCheckFolder.CountCheckedFolder : integer;
var
  node : tTreeNode;
begin
  result := 0;
  node := items[0];
  while node <> nil do
   begin
    if Node.StateIndex = CHECKED then
     inc ( result );
    node := Node.GetNext;
   end;
end;


procedure TDhCheckFolder.SwitchStateIndex ( node : tTreeNode; attr : ULONG );
var
  NodePath : string;
  DosAttr : word;
begin
  NodePath := GetDirectory ( FRootShellFolder, node.data, SHGDN_FORPARSING );
  //if NodePath = 'A:' then
  // beep;
  DosAttr := 0;
  if pos ( '\', NodePath ) > 0 then
   DosAttr := FileGetAttr ( NodePath );
  // this is for the virtual folder.
  if ( attr and SFGAO_FILESYSTEM = 0 )  then
   begin
    Node.StateIndex := -1;
    fSortFolder := false;
   end
    else if ( DosAttr and faSysFile > 0 ) then  // virtual folder, but with files,
     Node.StateIndex := NEUTRAL
      else
       if Node.StateIndex <> NEUTRAL then     // norrmal folder
        if node.parent.StateIndex = CHECKED then
         begin
          Node.StateIndex := CHECKED;
         end
          else Node.StateIndex := NOT_CHECKED;

  fCheckedFolderCount := CountCheckedFolder;
end; {TDhCheckFolder.SwitchStateIndex}


Procedure TDhCheckFolder.EnumerateFolder ( ShellFolder: IShellFolder; RealFolder : boolean;
                                                    AllFolder : boolean; node : tTreeNode );
var
  flags : DWORD;
  EnumList : IEnumIdList;
  FQ_PIDL, PidlPath, list : PItemIdList;
  fetched : ULONG;

  FolderName: string;
  attr : ULONG;
  HexAttr : string;
  ImageIndex : integer;
  flag : boolean;

Begin
  PidlPath := node.data;
  fSortFolder := true;
  flags := SHCONTF_FOLDERS or SHCONTF_INCLUDEHIDDEN;
  if ( ShellFolder.EnumObjects ( handle, flags, EnumList )) = NOERROR then
   begin
    while EnumList.Next ( 1, list, fetched ) = S_OK do
     begin
      ImageIndex := -1;
      FolderName := GetDirectory ( ShellFolder, list, SHGDN_NORMAL );
      attr := ALL_ATRIBUTES;
      ShellFolder.GetAttributesOf ( 1, list, attr );
      HexAttr := IntToHex (attr, 4);
      //if HexAttr = '0000' then           //NETWORK_MAIN_ATTR
      // beep;
      //if pos ( 'Recycled', FolderName ) > 0 then
      // beep;

      flag := false;
      // real folder + virtual folder
      if AllFolder then
       flag := true                                       // real folder
        else if RealFolder then flag := ( attr and SFGAO_FILESYSTEM > 0 )
         else if not RealFolder then                                // virtual folder
          flag :=  ( attr and SFGAO_FOLDER > 0 ) and ( attr and SFGAO_FILESYSTEM = 0 );

      if flag then
       begin
        FQ_PIDL := CombinePidls ( PidlPath, list );
        fFullPidlPathList.add ( FQ_PIDL );
        ImageIndex := GetNormalIcon ( FQ_PIDL );

        node := items.AddChildObject ( node, FolderName, FQ_PIDL );
        if ( attr and SFGAO_HASSUBFOLDER > 0 ) then
         Node.HasChildren := true;
        Node.ImageIndex := ImageIndex;
        Node.SelectedIndex := GetSelectedIcon ( FQ_PIDL );
        // image with hand-icon
        if ( SFGAO_SHARE and attr ) > 0 then
         Node.OverlayIndex := 0;
        // switch State-Icon
        SwitchStateIndex ( node, attr );

        node := node.parent;
       end;
      ShellMalloc.free ( list );
      // filter out client + server
      if ( ImageIndex = WHOLE_NETWORK_ICON ) and ( fCheckBoxes ) then
       break;
     end; // end while do ..
   end;
End;


procedure TDhCheckFolder.Change ( Node: TTreeNode );
begin
  if not fFirstRead then fHasChanged := true;
  fFirstRead := false;
  node := selected;
  fCurNode := node;
  fPidlPath := node.data;
  if fPidlPath <> nil then
   begin
    if Node.StateIndex >= 0 then
     fCurDir := GetDirectory ( FRootShellFolder, fPidlPath, SHGDN_FORPARSING )
      else fCurDir := node.text;
    if ( assigned(FOnChangeFolder)) then FOnChangeFolder ( fCurDir );
   end;
  inherited;
end;


procedure TDhCheckFolder.Click;
var
  //state : integer;
  NodePath : string;
Begin
  if fCurNode <> nil then
   begin
    if fCanExpand then         // node clicked
     AddSubNodesWithNode ( fCurNode )
      else                     // state clicked
       begin
        NodePath := GetDirectory ( FRootShellFolder, fCurNode.data,  SHGDN_FORPARSING );
        // Check nodes and update fCheckedFolderList
        if ProofStates ( fCurNode ) then
         fCheckedFolderCount := CountCheckedFolder;
        { state := GetStateChecked;
        // Only check files, if node is selected.
        if FCurNode = selected then
         if assigned ( FCheckFiles ) then
          FCheckFiles.CheckAllFiles ( state, false );}
       end;
     if fHasChanged then // Show files in ListView
      //if assigned ( FCheckFiles ) then
      // FCheckFiles.RunReadFilesThread ( FPidlPath, FCurDir, true, GetStateChecked );
   end;
  fHasChanged := false;
  inherited;
end; { Click }


procedure TDhCheckFolder.MouseMove ( Shift: TShiftState; X, Y: Integer );
var
  ht : THitTests;
begin
  fCanExpand := true;
  if screen.cursor <> crHourGlass then
   begin
    fCurNode := GetNodeAt ( x, y );
    ht :=  GetHitTestInfoAt ( x, y  );
    if htOnStateIcon in ht then
     begin
      fCanExpand := false;
      screen.cursor := crPencil;
     end
      else
       screen.cursor := crDefault;
   end;
  inherited;
end;


procedure TDhCheckFolder.Changing ( Sender: TObject; Node: TTreeNode;
                                                               var AllowChange: boolean );
begin
  if not fCanExpand
   then AllowChange := false;
end;


function TDhCheckFolder.CanExpand ( node: TTreeNode ) : boolean;
begin
  result := fCanExpand;
end;


function TDhCheckFolder.CanCollapse ( node: TTreeNode ) : boolean;
begin
  result := fCanExpand;
end;


procedure TDhCheckFolder.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
end;


procedure TDhCheckFolder.KeyDown (  var Key : Word; Shift: TShiftState );
var
  node : tTreeNode;
begin
  fCanExpand := false;
  node := selected;
  // if right Cursor-Key is pressed.
  if Key = VK_RIGHT then AddSubNodesWithNode ( node );
  Application.ProcessMessages;
  fCanExpand := true;

  //if Key = VK_F5 then
  // RefreshNode ( node );
  inherited;
end;


procedure TDhCheckFolder.KeyUp (  var Key: Word; Shift: TShiftState );
begin
  {if fCanExpand then   // Show files in ListView
   if assigned ( FCheckFiles ) then
    FCheckFiles.RunReadFilesThread ( FPidlPath, FCurDir, false, GetStateChecked );}
  inherited;
end;


Procedure TDhCheckFolder.AddSubNodesWithNode ( node : tTreeNode );
var
  idList : pItemIDList;
  ShellFolder : iShellFolder;
  attr : DWORD;
  IsNetWork : boolean;
  //NetNode : tTreeNode;
  ChildNode : tTreeNode;
Begin
  IsNetWork := false;
  // Refresh Network
  attr := GetFolderAttribut ( node.data );
  if ( attr = fNetworkSubAttr ) and ( node.GetFirstChild <> nil ) then
   if ( node.GetFirstChild.StateIndex = -1 ) then
    begin
     while 1=1 do
      begin
       if ( Node.GetNext <> nil ) then
        begin
         ChildNode := Node.GetNext;
         // only refrsh, if there one sibling childs
         if ChildNode.GetNext = nil then
          begin
           IsNetWork := true;
           Node.GetNext.delete;
          end
           else break;
        end
         else break;
      end;
   end;
  if (( node.HasChildren ) and ( node.GetFirstChild = nil )) or IsNetWork then
   begin
    screen.cursor := crHourGlass;
    idList := node.data;
    FRootShellFolder.BindToObject ( idList,  nil, IID_IShellFolder,
                                                       pointer ( ShellFolder ));
    EnumerateFolder ( ShellFolder, true, true, node );
    if fSortFolder then TreeView_SortChildren ( handle, node.ItemId, 0 ); // hTreeItem
    if ( node.HasChildren ) and ( node.GetFirstChild = nil ) then
     if ( pos ( DOUBLE_SLASH, fCurDir ) > 0 ) or
      ( pos ( LowerCase(DESKTOP_PATH), LowerCase(fCurDir) ) > 0 ) then
       Node.HasChildren := false;
    screen.cursor := crDefault;
    fItemsCount := items.count;
   end;
End;


function TDhCheckFolder.ProofStates ( node : tTreeNode ) : boolean;
var
  rect : tRect;
  DispRect : tRect;
  ChildNode : tTreeNode;
  NodeVisible : boolean;
Begin
  rect := ClientRect;
  fCanExpand := false;
  NodeVisible := false;
  result := false;
  if Node.StateIndex = NEUTRAL then exit;

  if ( Node.StateIndex = NOT_CHECKED ) or ( Node.StateIndex = GRAY_CHECKED ) then
   begin
    node.StateIndex := CHECKED;
    result := true;
   end
    else
     if ( node.StateIndex = CHECKED ) then Node.StateIndex := NOT_CHECKED;

  ValidateRect ( handle, @rect );
  ChildNode := Node.GetFirstchild;
  if ChildNode <> nil then
   if ChildNode.IsVisible then
    begin
     CheckParentFolder ( node );
     CheckSubFolder ( node );
     NodeVisible := true;
    end;
  if ( ChildNode = nil ) or ( not NodeVisible ) then  // check only one node
   begin
    DispRect := Node.DisplayRect ( true );
    DispRect.top := DispRect.top + 4;
    DispRect.left := DispRect.left - 34;
    DispRect.right := DispRect.left + 16;
    DispRect.Bottom := DispRect.Bottom - 4;
    InvalidateRect ( handle, @DispRect, false );
    CheckParentFolder ( node );
    CheckSubFolder ( node );
   end
    else
     begin
      ValidateRect ( handle, @rect );
      InvalidateRect ( handle, @rect, false );
     end;
End;


function TDhCheckFolder.SubFolderChecked ( node : tTreeNode ) : boolean;
var
  level : integer;
Begin
  result := false;
  level := node.level;
  node := node.GetFirstChild;
  while node <> nil do
   begin
    if ( node = nil ) or ( node.level <= level ) then
     break;
    if ( Node.StateIndex = GRAY_CHECKED ) or ( Node.StateIndex = CHECKED ) then
     begin
      result := true;
      break;
     end;
    Node := Node.GetNext;
   end;
End; {TDhCheckFolder.SubFolderChecked}


procedure TDhCheckFolder.CheckSubFolder ( node : tTreeNode );
var
  state : integer;
  level : integer;
Begin
  level := node.level;
  state := node.StateIndex;
  node := node.GetFirstChild;
  while node <> nil do
   begin
    if ( node = nil ) or ( node.level <= level ) then
     break;
    if Node.StateIndex <> NEUTRAL then
     begin
      Node.StateIndex := state;
      // Check files in ListView.
      {if node = selected then
       if assigned ( FCheckFiles ) then
        FCheckFiles.CheckAllFiles ( state, false );}
     end;
    Node := Node.GetNext;
   end;

  fCheckedFolderCount := CountCheckedFolder;
End; {TDhCheckFolder.CheckSubFolder}


procedure TDhCheckFolder.CheckParentFolder ( node : tTreeNode );
var
  AllFolderChecked : boolean;
  NodePath : string;
Begin
  while node.parent.level >= 1 do
   begin
    NodePath := GetDirectory ( FRootShellFolder, Node.Parent.data,  SHGDN_FORPARSING );
    if Node.Parent.StateIndex < 0 then
     begin
      node := node.parent;
      continue;
     end;
    AllFolderChecked := CheckSibling ( node.parent );

    if AllFolderChecked then
     begin
      Node.Parent.StateIndex := CHECKED;
     end
      else
      if ( not AllFolderChecked ) and ( not FSomeFolderChecked ) then
       Node.Parent.StateIndex := NOT_CHECKED
        else
        if FSomeFolderChecked then
         Node.Parent.StateIndex := GRAY_CHECKED;
    node := node.parent;
   end;
  fCheckedFolderCount := CountCheckedFolder;
End; {TDhCheckFolder.CheckParentFolder}


function TDhCheckFolder.CheckSibling ( node : tTreeNode ) : boolean;
var
  folder : string;

Begin
  result := true; // if all folder are checked
  FSomeFolderChecked := false;

  Node := Node.GetFirstChild;
  while node <> nil do
   begin
    folder := node.text;
    if ( Node.StateIndex = CHECKED ) then
     FSomeFolderChecked := true;
    if ( Node.StateIndex = GRAY_CHECKED ) then
     begin
      FSomeFolderChecked := true;
      result := false;
      break;
     end
      else
       if Node.StateIndex = NOT_CHECKED then
        result := false;
    Node := Node.GetNextSibling;
   end;
End;


function TDhCheckFolder.FindNodeInTreeView ( StartNode : tTreeNode; path : string ) : integer;
var
  PidlPath : pItemIdList;
  NodePath : string;
  node : tTreeNode;
  IsFolder : boolean;
Begin
  result := -1;
  node := StartNode;
  IsFolder := false;
  if ( pos ( ':', path ) <= 0 ) and ( pos ( DOUBLE_SLASH, path ) = 0 ) then
   IsFolder := true
    else
     path := RemoveSlash ( path );

  while node <> nil do
   begin
    //if pos ( 'Server', node.text ) > 0 then
    //if node.text = 'Server' then
    // beep;
    PidlPath := node.data;
    if PidlPath <> nil then
     NodePath := GetDirectory ( FRootShellFolder, PidlPath,  SHGDN_FORPARSING );
     if IsFolder then
      NodePath := node.text;
     if CompareText ( LowerCase(path), LowerCase(NodePath) ) = 0 then
      begin
       result := node.AbsoluteIndex;
       break;
      end;
    Node := Node.GetNext
   end;
End;


procedure TDhCheckFolder.ReCreatePathInTree ( path : string; node : tTreeNode;
                                                                      visible : boolean );
var
  SplitPathList : tStringList;
  i : integer;
  SplitPath : string;
  index : integer;
begin
  SplitPathList := tStringList.create;
  if pos ( '\', path ) > 0 then
   begin
    SplitPathToList ( path, SplitPathList );
    for i:=0 to SplitPathList.count-1 do
     begin
      SplitPath := SplitPathList[i];
      AddSubNodesWithFolder ( SplitPath, true, true );
     end;
   end;
  // find the path before deletion and make it visible
  if visible then
   begin
    index := FindNodeInTreeView ( items[0], path );
    if index > 0 then
     begin
      // node := items[index];
      items[index].MakeVisible;
     end;
   end;
  SplitPathList.free;
end;


function TDhCheckFolder.ExploreNetwork : boolean;
var
  node : tTreeNode;
Begin
  result := false;
  node := items[1];
  // Find Network-Main-Icon
  while node <> nil do
   begin
    //if node.text = 'Hallo' then
    // beep;
    if Node.ImageIndex = FNetWorkIcon then
     begin
      result := true;
      break;
     end;
    node := node.GetNextSibling; // Network-Icon
   end;
  if not result then
   begin
    exit;
   end;
  // add WholeNetwork-Icon
  result := false;
  AddSubNodesWithFolder ( node.text, false, false );
  // add Workgroup-Icon
  if Node.GetFirstChild <> nil then
   node := node.GetFirstChild
    else exit;
  AddSubNodesWithFolder ( node.text, false, false );
  // add hosts
  if Node.GetFirstChild <> nil then
   node := Node.GetFirstChild
    else exit;
  AddSubNodesWithFolder ( node.text, true, true );
  // add drives
  if node.GetFirstChild <> nil then
   node := node.GetFirstChild
    else exit;
  while node <> nil do
   begin
    if ( node.GetFirstChild = nil ) then
     if ( node.HasChildren ) then
      AddSubNodesWithFolder ( node.text, true, true );
     node := node.GetNextSibling;
   end;
  Application.ProcessMessages;
  result := true;
End; { ExploreNetwork }


procedure TDhCheckFolder.CreateStates;
var
  i : integer;
  bitmap : tBitmap;
  ResName : string;
begin
  bitmap := tBitmap.create;
  fStateImageList := tImageList.create(self);
  for i := 1 to 5 do
   begin
    ResName := 'TV_STATUS' + IntToStr(i);
    Bitmap.LoadFromResourceName ( hInstance, ResName );
    fStateImageList.add ( bitmap, nil );
   end;
  bitmap.free;
  StateImages := fStateImageList;
end;


procedure TDhCheckFolder.CreateImages;
var
 SysIL : uint;
 sfi : tshFileInfo;

begin
  Images := tImageList.create( self );
  SysIL := ShGetFileInfo ( '', 0, sfi, SizeOf(sfi), SHGFI_SYSICONINDEX or
                                                        SHGFI_SMALLICON );
  if SysIL <> 0 then
   begin
    Images.Handle := SysIL;
    Images.ShareImages := true;
   end;
  screen.cursors[crPencil] := LoadCursor ( HInstance, 'PENCIL_TV1' );
end;


procedure TDhCheckFolder.ClearAllItems;
var
  i : integer;
begin
  for i := 0 to fFullPidlPathList.count-1 do
  begin
   if fFullPidlPathList[i] <> nil then
    ShellMalloc.free ( fFullPidlPathList[i] );
  end;
  items.clear;
end;


Procedure Register;
Begin
  RegisterComponents ( 'DhComps', [TDhCheckFolder] );
End;


initialization
  ShGetMalloc ( ShellMalloc );



  END.


